#include "StepDirLineCoding.h"

/*
 * Macros
 */
#define Set_High(x) ( PORTB |= (1<<x) )
#define Set_Low(x) ( PORTB &= ~(1<<x) )

#define DelayUsec() asm volatile ("NOP" ::);asm volatile ("NOP" ::);asm volatile ("NOP" ::);asm volatile ("NOP" ::);asm volatile ("NOP" ::);asm volatile ("NOP" ::);asm volatile ("NOP" ::);asm volatile ("NOP" ::);


void StepDirLineCoding_Init(void)
{
	//Assuming we want them low as default??
	PORTB &= ~( (1<<STEP_X) | (1<<DIR_X) | (1<<STEP_Y) | (1<<DIR_Y) | (1<<STEP_Z) | (1<<DIR_Z) );
	//If we want thenm high by default
	//PORTB |= ( (1<<STEP_X) | (1<<DIR_X) | (1<<STEP_Y) | (1<<DIR_Y) | (1<<STEP_Z) | (1<<DIR_Z) );
	DDRB |= ( (1<<STEP_X) | (1<<DIR_X) | (1<<STEP_Y) | (1<<DIR_Y) | (1<<STEP_Z) | (1<<DIR_Z) );

}


void StartCodition(uint8_t step, uint8_t dir)
{
	Set_High(dir);
	Set_High(step);
	DelayUsec();
	DelayUsec();
	DelayUsec();
	DelayUsec();
	DelayUsec();
	Set_Low(dir);
	DelayUsec();
}

// The MM130 checks the status of DIR after receiving a 
// STEP raising edge.  DIR must be high before firing
// STEP.  If DIR goes low within 5 usec then the board 
// assumes this is a command function not a step
// function and decodes the data sent
void SendByte(uint8_t inchar,uint8_t axisselect)
{
	uint8_t axisdir,axisstep;
	uint8_t i;
	
	switch(axisselect)
	{
		
	
			
	
		case Y_AXIS:
	
			axisdir = DIR_Y;
			axisstep = STEP_Y;
			break;
	
		case Z_AXIS:
	
			axisdir = DIR_Z;
			axisstep = STEP_Z;
			break;

		case X_AXIS:

		default:

			axisdir = DIR_X;
			axisstep = STEP_X;
			break;
	}		
	


	StartCodition(axisstep,axisdir);
	
	for(i=0; i<8; i++)
	{
		Set_Low(axisstep);

		DelayUsec();//may be better to move this delay to after we modify 
		DelayUsec();
		DelayUsec();
		DelayUsec();
		DelayUsec();

		if(inchar&0x01)
		{
			Set_High(axisdir);
		}
		else
		{
			Set_Low(axisdir);
		}

		Set_High(axisstep);

		DelayUsec();
		DelayUsec();
		DelayUsec();
		DelayUsec();
		DelayUsec();
		inchar >>= 1;//shift the bits down
	}

	Set_Low(axisstep);
}


